!*****************************************************************************
!                                                                            *
!  FGIW6.F90                                                                 *
!                                                                            *
!  Demonstrate how to load a Fastgraph/Fonts font file from an FGI library.  *
!                                                                            *
!*****************************************************************************

integer*4 function WinMain (hInstance, hPrevInstance, lpszCmdParam, nCmdShow)
!MS$ATTRIBUTES STDCALL, ALIAS : '_WinMain@16' :: WinMain
use msfwina
use fgwin
use fgfwin
use fgiwin

interface
integer*4 function WindowProc (window, message, wParam, lParam)
!MS$ATTRIBUTES STDCALL, ALIAS:'_WindowProc@16' :: WindowProc
integer*4 window, message, wParam, lParam
end function WindowProc
end interface

integer*4 hInstance, hPrevInstance, lpszCmdParam, nCmdShow

character*12      AppName
integer*4         iret
integer*4         window
type (T_MSG)      msg
type (T_WNDCLASS) wndclass

data AppName /'FGIW6'C/

if (hPrevInstance == 0) then
   wndclass%style         = CS_HREDRAW .or. CS_VREDRAW .or. CS_OWNDC
   wndclass%lpfnWndProc   = LOC(WindowProc)
   wndclass%cbClsExtra    = 0
   wndclass%cbWndExtra    = 0
   wndclass%hInstance     = hInstance
   wndclass%hIcon         = LoadIcon(NULL,IDI_APPLICATION)
   wndclass%hCursor       = LoadCursor(NULL,IDC_ARROW)
   wndclass%hbrBackground = NULL
   wndclass%lpszMenuName  = NULL
   wndclass%lpszClassName = LOC(AppName)
   iret = RegisterClass(wndclass)
   lpszCmdParam = lpszCmdParam
end if

window = CreateWindow(    &
   AppName,               &  ! window class name
   'Example FGIW6'C,      &  ! window caption
   WS_OVERLAPPEDWINDOW,   &  ! window style
   CW_USEDEFAULT,         &  ! initial x position
   CW_USEDEFAULT,         &  ! initial y position
   CW_USEDEFAULT,         &  ! initial x size
   CW_USEDEFAULT,         &  ! initial y size
   NULL,                  &  ! parent window handle
   NULL,                  &  ! window menu handle
   hInstance,             &  ! program instance handle
   NULL)                     ! creation parameters

iret = ShowWindow(window,nCmdShow)
iret = UpdateWindow(window)

do while (GetMessage(msg,NULL,0,0))
   iret = TranslateMessage(msg)
   iret = DispatchMessage(msg)
end do

WinMain = msg%wParam
return
end

!*****************************************************************************
!                                                                            *
!  WindowProc                                                                *
!                                                                            *
!  Window procedure to handle messages sent to the window.                   *
!                                                                            *
!*****************************************************************************

integer*4 function WindowProc (window, message, wParam, lParam)
!MS$ATTRIBUTES STDCALL, ALIAS:'_WindowProc@16' :: WindowProc
use msfwina
use fgwin
use fgfwin
use fgiwin
integer*4 window, message, wParam, lParam

type (T_PAINTSTRUCT) ps
integer*4 cxClient, cyClient
integer*4 hdc, hpal, hvb, hfgi
integer*4 size
integer*4 iret

integer*1,allocatable::buffer(:)

save cxClient, cyClient, hdc, hpal, hvb, hfgi

WindowProc = 0

select case (message)
   case (WM_CREATE)
      hdc = GetDC(window)
      call fg_setdc(hdc)
      hpal = fg_defpal()
      call fg_realize(hpal)

      call fg_vbinit
      hvb = fg_vballoc(320,200)
      iret = fg_vbopen(hvb)
      call fg_vbcolors

      hfgi = fgi_open('EXAMPLE.FGI'C)
      if (hfgi == 0) then
         iret = MessageBox(window,'Unable to open FGI file.'C,'Error'C, &
                           MB_ICONSTOP.or.MB_OK)
         iret = DestroyWindow(window)
         return
      end if
      size = fgi_filesize('BRODWY18.FGF'C,hfgi)
      allocate (buffer(size))
      iret = fgi_readnext(buffer,size,hfgi)
      call fgi_close(hfgi)

      iret = fgf_define(buffer)
      call fgf_justify(0,0)
      call fg_setcolor(255)
      call fg_fillpage
      call fg_setcolor(20)
      call fg_move(160,100)
      call fgf_print('BROADWAY FONT'C,13);
      return

   case (WM_PAINT)
      iret = BeginPaint(window,ps)
      call fg_vbscale(0,fg_getmaxx(),0,fg_getmaxy(),0,cxClient-1,0,cyClient-1)
      iret = EndPaint(window,ps)
      return

   case (WM_SETFOCUS)
      call fg_realize(hpal)
      iret = InvalidateRect(window,NULL_RECT,.TRUE.)
      return

   case (WM_SIZE)
      cxClient = LOWORD(lParam)
      cyClient = HIWORD(lParam)
      return

   case (WM_DESTROY)
      deallocate (buffer)
      call fg_vbclose
      call fg_vbfree(hvb)
      call fg_vbfin
      iret = DeleteObject(hpal)
      iret = ReleaseDC(window,hdc)
      call PostQuitMessage(0)
      return
end select

WindowProc = DefWindowProc(window,message,wParam,lParam)
return
end
